---
title: MediaDevices.getUserMedia()
slug: Web/API/MediaDevices/getUserMedia
tags:
  - API
  - Audio
  - Capture
  - Media
  - Media Capture and Streams API
  - Media Streams API
  - MediaDevices
  - Method
  - Photos
  - Reference
  - Video
  - WebRTC
  - getusermedia
---
<div>{{APIRef("Media Capture and Streams")}}</div>

<p><span class="seoSummary">The {{domxref("MediaDevices")}}<code><strong>.getUserMedia()</strong></code> method prompts the user for permission to use a media input which produces a {{domxref("MediaStream")}} with tracks containing the requested types of media.</span> That stream can include, for example, a video track (produced by either a hardware or virtual video source such as a camera, video recording device, screen sharing service, and so forth), an audio track (similarly, produced by a physical or virtual audio source like a microphone, A/D converter, or the like), and possibly other track types.</p>

<p>It returns a {{jsxref("Promise")}} that resolves to a {{domxref("MediaStream")}} object. If the user denies permission, or matching media is not available, then the promise is rejected with <code>NotAllowedError</code> or <code>NotFoundError</code> respectively.</p>

<div class="note">
<p><strong>Note:</strong> It's possible for the returned promise to <em>neither</em> resolve nor reject, as the user is not required to make a choice at all and may ignore the request.</p>
</div>

<p>Generally, you will access the {{domxref("MediaDevices")}} singleton object using {{domxref("navigator.mediaDevices")}}, like this:</p>

<pre class="brush: js">async function getMedia(constraints) {
  let stream = null;

  try {
    stream = await navigator.mediaDevices.getUserMedia(constraints);
    /* use the stream */
  } catch(err) {
    /* handle the error */
  }
}
</pre>

<p>Similarly, using the raw promises directly, the code looks like this:</p>

<pre class="brush: js">navigator.mediaDevices.getUserMedia(constraints)
.then(function(stream) {
  /* use the stream */
})
.catch(function(err) {
  /* handle the error */
});</pre>

<div class="notecard note">
<p><strong>Note:</strong> If the current document isn't loaded securely, <code>navigator.mediaDevices</code> will be <code>undefined</code>, and you cannot use <code>getUserMedia()</code>. See {{anch("Security")}} for more information on this and other security issues related to using <code>getUserMedia()</code>.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <var>promise</var> = navigator.mediaDevices.getUserMedia(<var>constraints</var>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>constraints</var></code></dt>
 <dd>
 <p>A {{domxref("MediaStreamConstraints")}} object specifying the types of media to request, along with any requirements for each type.</p>

 <p>The <code><var>constraints</var></code> parameter is a <code>MediaStreamConstraints</code> object with two members: <code>video</code> and <code>audio</code>, describing the media types requested. Either or both must be specified. If the browser cannot find all media tracks with the specified types that meet the constraints given, then the returned promise is rejected with <code>NotFoundError</code>.</p>

 <p>The following requests both audio and video without any specific requirements:</p>

 <pre class="brush: js">{ audio: true, video: true }</pre>

 <p>If <code>true</code> is specified for a media type, the resulting stream is <em>required</em> to have that type of track in it. If one cannot be included for any reason, the call to <code>getUserMedia()</code> will result in an error.</p>

 <p>While information about a user's cameras and microphones are inaccessible for privacy reasons, an application can request the camera and microphone capabilities it needs and wants, using additional constraints. The following expresses a preference for 1280x720 camera resolution:</p>

 <pre class="brush: js">{
  audio: true,
  video: { width: 1280, height: 720 }
}</pre>

 <p id="successCallback">The browser will try to honour this, but may return other resolutions if an exact match is not available, or the user overrides it.</p>

 <p>To <em>require</em> a capability, use the keywords <code>min</code>, <code>max</code>, or <code>exact</code> (a.k.a. <code>min == max</code>). The following demands a minimum resolution of 1280x720:</p>

 <pre class="brush: js">{
  audio: true,
  video: {
    width: { min: 1280 },
    height: { min: 720 }
  }
}</pre>

 <p>If no camera exists with this resolution or higher, then the returned promise will be rejected with <code>OverconstrainedError</code>, and the user will not be prompted.</p>

 <p>The reason for the difference in behaviour is that the keywords <code>min</code>, <code>max</code>, and <code>exact</code> are inherently mandatory. Whereas plain values and a keyword called <code>ideal</code> are not. Here's a full example:</p>

 <pre class="brush: js">{
  audio: true,
  video: {
    width: { min: 1024, ideal: 1280, max: 1920 },
    height: { min: 576, ideal: 720, max: 1080 }
  }
}</pre>

 <p>An <code>ideal</code> value, when used, has gravity, which means that the browser will try to find the setting (and camera, if you have more than one), with the smallest <a href="https://w3c.github.io/mediacapture-main/#dfn-fitness-distance">fitness distance</a> from the ideal values given.</p>

 <p>Plain values are inherently ideal, which means that the first of our resolution examples above could have been written like this:</p>

 <pre class="brush: js">{
  audio: true,
  video: {
    width: { ideal: 1280 },
    height: { ideal: 720 }
  }
}</pre>

 <p>Not all constraints are numbers. For example, on mobile devices, the following will prefer the front camera (if one is available) over the rear one:</p>

 <pre class="brush: js">{ audio: true, video: { facingMode: "user" } }</pre>

 <p>To <em>require</em> the rear camera, use:</p>

 <pre class="brush: js">{ audio: true, video: { facingMode: { exact: "environment" } } }</pre>

 <p>Another non-number constraint is the <code>deviceId</code> constraint. If you have a <code>deviceId</code> from {{domxref("mediaDevices.enumerateDevices()")}}, you can use it to request a specific device:</p>

 <pre class="brush: js">{ video: { deviceId: myPreferredCameraDeviceId } }</pre>

 <p>The above will return the camera you requested, or a different camera if that specific camera is no longer available. Again, to <em>require</em> the specific camera, you would use:</p>

 <pre class="brush: js">{ video: { deviceId: { exact: myExactCameraOrBustDeviceId } } }</pre>
 </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref("Promise")}} whose fulfillment handler receives a {{domxref("MediaStream")}} object when the requested media has successfully been obtained.</p>

<h3 id="Exceptions">Exceptions</h3>

<p>Rejections of the returned promise are made by passing a {{domxref("DOMException")}} error object to the promise's failure handler. Possible errors are:</p>

<dl>
 <dt><code>AbortError</code></dt>
 <dd>Although the user and operating system both granted access to the hardware device, and no hardware issues occurred that would cause a <code>NotReadableError</code>, some problem occurred which prevented the device from being used.</dd>
 <dt><code>NotAllowedError</code></dt>
 <dd>One or more of the requested source devices cannot be used at this time. This will happen if the browsing context is insecure (that is, the page was loaded using HTTP rather than HTTPS). It also happens if the user has specified that the current browsing instance is not permitted access to the device, the user has denied access for the current session, or the user has denied all access to user media devices globally. On browsers that support managing media permissions with <a href="/en-US/docs/Web/HTTP/Feature_Policy">Feature Policy</a>, this error is returned if Feature Policy is not configured to allow access to the input source(s).
 <div class="note">Older versions of the specification used <code>SecurityError</code> for this instead; <code>SecurityError</code> has taken on a new meaning.</div>
 </dd>
 <dt><code>NotFoundError</code></dt>
 <dd>No media tracks of the type specified were found that satisfy the given constraints.</dd>
 <dt><code>NotReadableError</code></dt>
 <dd>Although the user granted permission to use the matching devices, a hardware error occurred at the operating system, browser, or Web page level which prevented access to the device.</dd>
 <dt><code>OverconstrainedError</code></dt>
 <dd>The specified constraints resulted in no candidate devices which met the criteria requested. The error is an object of type <code>OverconstrainedError</code>, and has a <code>constraint</code> property whose string value is the name of a constraint which was impossible to meet, and a <code>message</code> property containing a human-readable string explaining the problem.
 <div class="note">Because this error can occur even when the user has not yet granted permission to use the underlying device, it can potentially be used as a fingerprinting surface.</div>
 </dd>
 <dt><code>SecurityError</code></dt>
 <dd>User media support is disabled on the {{domxref("Document")}} on which <code>getUserMedia()</code> was called. The mechanism by which user media support is enabled and disabled is left up to the individual user agent.</dd>
 <dt><code>TypeError</code></dt>
 <dd>The list of constraints specified is empty, or has all constraints set to <code>false</code>. This can also happen if you try to call <code>getUserMedia()</code> in an insecure context, since {{domxref("navigator.mediaDevices")}} is <code>undefined</code> in an insecure context.</dd>
</dl>

<h2 id="Privacy_and_security">Privacy and security</h2>

<p>As an API that may involve significant privacy concerns, <code>getUserMedia()</code>'s specification lays out a wide array of privacy and security requirements that browsers are obligated to meet.</p>

<p><code>getUserMedia()</code> is a powerful feature which can only be used in <a href="/en-US/docs/Web/Security/Secure_Contexts">secure contexts</a>; in insecure contexts, <code>navigator.mediaDevices</code> is <code>undefined</code>, preventing access to <code>getUserMedia()</code>. A secure context is, in short, a page loaded using HTTPS or the <code>file:///</code> URL scheme, or a page loaded from <code>localhost</code>.</p>

<p>In addition, user permission is always required to access the user's audio and video inputs. Only a window's top-level document context for a valid origin can even request permission to use <code>getUserMedia()</code>, unless the top-level context expressly grants permission for a given {{HTMLElement("iframe")}} to do so using <a href="/en-US/docs/Web/HTTP/Feature_Policy">Feature Policy</a>. Otherwise, the user will never even be asked for permission to use the input devices.</p>

<p>For additional details on these requirements and rules, how they are reflected in the context in which your code is running, and about how browsers manage user privacy and security issues, read on.</p>

<h3 id="User_privacy">User privacy</h3>

<p>As an API that may involve significant privacy concerns, <code>getUserMedia()</code> is held by the specification to very specific requirements for user notification and permission management. First, <code>getUserMedia()</code> must always get user permission before opening any media gathering input such as a webcam or microphone. Browsers may offer a once-per-domain permission feature, but they must ask at least the first time, and the user must specifically grant ongoing permission if they choose to do so.</p>

<p>Of equal importance are the rules around notification. Browsers are required to display an indicator that shows that a camera or microphone is in use, above and beyond any hardware indicator that may exist. They must also show an indicator that permission has been granted to use a device for input, even if the device is not actively recording at the moment.</p>

<p>For example in Firefox,<strong> </strong>the URL bar displays a pulsing red icon to indicate that recording is underway. The icon is gray if the permission is in place but recording is not currently underway. The device's physical light is used to indicate whether or not recording is currently active. If you've muted your camera (so-called "facemuting"), your camera's activity light goes out to indicate that the camera is not actively recording you, without discarding the permission to resume using the camera once muting is over.</p>

<h3 id="Security">Security</h3>

<p>There are a number of ways security management and controls in a {{Glossary("user agent")}} can cause <code>getUserMedia()</code> to return a security-related error.</p>

<div class="notecard note">
<p><strong>Note:</strong> The security model for <code>getUserMedia()</code> is still somewhat in flux. The originally-designed security mechanism is in the process of being replaced with Feature Policy, so various browsers have different levels of security support, using different mechanisms. You should test your code carefully on a variety of devices and browsers to be sure it is as broadly compatible as possible</p>
</div>

<h4 id="Feature_Policy">Feature Policy</h4>

<p>The <a href="/en-US/docs/Web/HTTP/Feature_Policy">Feature Policy</a> security management feature of {{Glossary("HTTP")}} is in the process of being introduced into browsers, with support available to some extent in many browsers (though not always enabled by default, as in Firefox). <code>getUserMedia()</code> is one method which will require the use of Feature Policy, and your code needs to be prepared to deal with this. For example, you may need to use the {{htmlattrxref("allow", "iframe")}} attribute on any {{HTMLElement("iframe")}} that uses <code>getUserMedia()</code>, and pages that use <code>getUserMedia()</code> will eventually need to supply the {{HTTPHeader("Feature-Policy")}} header.</p>

<p>The two permissions that apply to <code>getUserMedia()</code> are <code>camera</code> and <code>microphone</code>.</p>

<p>For example, this line in the HTTP headers will enable use of a camera for the document and any embedded {{HTMLElement("iframe")}} elements that are loaded from the same origin:</p>

<pre>Feature-Policy: camera 'self'</pre>

<p>This will request access to the microphone for the current origin and the specific origin https://developer.mozilla.org:</p>

<pre>Feature-Policy: microphone 'self' https://developer.mozilla.org</pre>

<p>If you're using <code>getUserMedia()</code> within an <code>&lt;iframe&gt;</code>, you can request permission just for that frame, which is clearly more secure than requesting a more general permission. Here, indicate we need the ability to use both camera and microphone:</p>

<pre class="brush: html">&lt;iframe src="https://mycode.example.net/etc" allow="camera;microphone"&gt;
&lt;/iframe&gt;</pre>

<p>Read our guide, <a href="/en-US/docs/Web/HTTP/Feature_Policy/Using_Feature_Policy">Using Feature Policy</a>, to learn more about how it works.</p>

<h4 id="Encryption_based_security">Encryption based security</h4>

<p>The <code>getUserMedia()</code> method is only available in <a href="/en-US/docs/Web/Security/Secure_Contexts">secure contexts</a>. A secure context is one the browser is reasonably confident contains a document which was loaded securely, using HTTPS/TLS, and has limited exposure to insecure contexts. If a document isn't loaded in a secure context, the {{domxref("navigator.mediaDevices")}} property is <code>undefined</code>, making access to <code>getUserMedia()</code> impossible.</p>

<p>Attempting to access <code>getUserMedia()</code> in this situation will result in a <code>TypeError</code>.</p>

<h4 id="Document_source_security">Document source security</h4>

<p>Because of the obvious security concern associated with <code>getUserMedia()</code> if used unexpectedly or without security being carefully managed, it can only be used in secure contexts. There are a number of insecure ways to load a document that might, in turn, attempt to call <code>getUserMedia()</code>. The following are examples of situations in which <code>getUserMedia()</code> is not permitted to be called:</p>

<ul>
 <li>A document loaded into a sandboxed {{HTMLElement("iframe")}} element cannot call <code>getUserMedia()</code> unless the <code>&lt;iframe&gt;</code> has its {{htmlattrxref("sandbox", "iframe")}} attribute set to <code>allow-same-origin</code>.</li>
 <li>A document loaded using a <code>data://</code> or <code>blob://</code> URL which has no origin (such as when one of these URLs is typed by the user into the address bar) cannot call <code>getUserMedia()</code>. These kinds of URLs loaded from JavaScript code inherit the script's permissions.</li>
 <li>Any other situation in which there is no origin, such as when the {{htmlattrxref("srcdoc", "iframe")}} attribute is used to specify the contents of a frame.</li>
</ul>

<h2 id="Examples">Examples</h2>

<h3 id="Width_and_height">Width and height</h3>

<p>This example gives a preference for camera resolution, and assigns the resulting {{domxref("MediaStream")}} object to a video element.</p>

<pre class="brush: js">// Prefer camera resolution nearest to 1280x720.
var constraints = { audio: true, video: { width: 1280, height: 720 } };

navigator.mediaDevices.getUserMedia(constraints)
.then(function(mediaStream) {
  var video = document.querySelector('video');
  video.srcObject = mediaStream;
  video.onloadedmetadata = function(e) {
    video.play();
  };
})
.catch(function(err) { console.log(err.name + ": " + err.message); }); // always check for errors at the end.
</pre>

<h3 id="Using_the_new_API_in_older_browsers">Using the new API in older browsers</h3>

<p>Here's an example of using <code>navigator.mediaDevices.getUserMedia()</code>, with a polyfill to cope with older browsers. Note that this polyfill does not correct for legacy differences in constraints syntax, which means constraints won't work well across browsers. It is recommended to use the <a href="https://github.com/webrtc/adapter">adapter.js</a> polyfill instead, which does handle constraints.</p>

<pre class="brush: js">// Older browsers might not implement mediaDevices at all, so we set an empty object first
if (navigator.mediaDevices === undefined) {
  navigator.mediaDevices = {};
}

// Some browsers partially implement mediaDevices. We can't just assign an object
// with getUserMedia as it would overwrite existing properties.
// Here, we will just add the getUserMedia property if it's missing.
if (navigator.mediaDevices.getUserMedia === undefined) {
  navigator.mediaDevices.getUserMedia = function(constraints) {

    // First get ahold of the legacy getUserMedia, if present
    var getUserMedia = navigator.webkitGetUserMedia || navigator.mozGetUserMedia;

    // Some browsers just don't implement it - return a rejected promise with an error
    // to keep a consistent interface
    if (!getUserMedia) {
      return Promise.reject(new Error('getUserMedia is not implemented in this browser'));
    }

    // Otherwise, wrap the call to the old navigator.getUserMedia with a Promise
    return new Promise(function(resolve, reject) {
      getUserMedia.call(navigator, constraints, resolve, reject);
    });
  }
}

navigator.mediaDevices.getUserMedia({ audio: true, video: true })
.then(function(stream) {
  var video = document.querySelector('video');
  // Older browsers may not have srcObject
  if ("srcObject" in video) {
    video.srcObject = stream;
  } else {
    // Avoid using this in new browsers, as it is going away.
    video.src = window.URL.createObjectURL(stream);
  }
  video.onloadedmetadata = function(e) {
    video.play();
  };
})
.catch(function(err) {
  console.log(err.name + ": " + err.message);
});
</pre>

<h3 id="Frame_rate">Frame rate</h3>

<p>Lower frame-rates may be desirable in some cases, like WebRTC transmissions with bandwidth restrictions.</p>

<pre class="brush: js">var constraints = { video: { frameRate: { ideal: 10, max: 15 } } };
</pre>

<h3 id="Front_and_back_camera">Front and back camera</h3>

<p>On mobile phones.</p>

<pre class="brush: js">var front = false;
document.getElementById('flip-button').onclick = function() { front = !front; };

var constraints = { video: { facingMode: (front? "user" : "environment") } };
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('Media Capture', '#dom-mediadevices-getusermedia', 'MediaDevices.getUserMedia()')}}</td>
   <td>{{Spec2('Media Capture')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.MediaDevices.getUserMedia")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The older {{domxref("navigator.getUserMedia()")}} legacy API.</li>
 <li>{{domxref("mediaDevices.enumerateDevices()")}}: Listing available media devices</li>
 <li><a href="/en-US/docs/Web/API/WebRTC_API">WebRTC API</a></li>
 <li><a href="/en-US/docs/Web/API/Media_Streams_API">Media Capture and Streams API (Media Streams)</a></li>
 <li><a href="/en-US/docs/Web/API/Screen_Capture_API">Screen Capture API</a>: Capturing screen contents as a {{domxref("MediaStream")}}</li>
 <li>{{domxref("mediaDevices.getDisplayMedia()")}}: Getting a stream containing screen contents</li>
 <li><a href="/en-US/docs/Web/API/WebRTC_API/Taking_still_photos">Taking webcam photos</a>: A tutorial on using <code>getUserMedia()</code> to take still photos rather than video</li>
</ul>
